<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { computed, ref } from 'vue';
import type { Ref } from 'vue';
import { useTimelineStore } from '@/stores/timeline';
import ElementDropdown from '@/components/timeline/ElementDropdown.vue';
import Embedded from '@/components/general/Embedded.vue';
import TextView from '@/components/general/TextView.vue';
import Modal from '@/components/general/Modal.vue';
import { handleModeEnum, userType } from '@/enums/enums';
import useTimeline from '@/hooks/useTimeline';
import LikeButton from '@/components/general/LikeButton.vue';
import Button from '@/components/general/Button.vue';
import { getFileType } from '@/lib/utils';
import MagnifiedPost from '@/components/general/MagnifiedPost.vue';

const props = defineProps<{
    post: any,
    postIndex: number
}>();

const store = useTimelineStore();
const { getFullUsable, getCommentsAllowed, handleMode, getStyle, elementId, elementTitle, elementText, elementInfo, elementBody, postIndex, getUserType, getLikesAllowed, showComments, getLineElementsColor, getLineSize, elementColor } = storeToRefs(store);
const methods = useTimeline();

const handle: Ref<HTMLElement | null> = ref(null);
const element: Ref<HTMLElement | null> = ref(null);


const editPost = () => {
    elementId.value = props.post.id;
    elementText.value = props.post.title.post;
    elementTitle.value = props.post.title.headline;
    elementInfo.value = props.post.info;
    elementBody.value = props.post.body;
    elementColor.value = props.post.color;
    handleMode.value = handleModeEnum.EDIT;
}

const openCommentCanvas = () => {
    postIndex.value = props.postIndex;
    showComments.value = true;
}

const getCommentsLength = computed(() => {
    if (getUserType.value === userType.ADMIN || getUserType.value === userType.MODERATOR) {
        return props.post.comments.length;
    } else {
        return props.post.comments.filter((comment: any) => comment.visible).length;
    }
});

const likePostHandler = () => {
    if (getFullUsable.value)
        store.likePost({ postIndex: props.postIndex });
}

const changeVisibility = (value: boolean) => {
    store.editPostProps({ postIndex: props.postIndex, visible: value });
}

const submitAuthorization = () => {
    store.editPostProps({ postIndex: props.postIndex, authorized: true });
};

const isRejectDeleteModal = ref(false);
const showRejectDeleteModal = (value: boolean) => {
    isRejectDeleteModal.value = value;
}

const rejectAuthorization = () => {
    store.deletePost({ postIndex: props.postIndex, postId: props.post.id });
};

const postWidthComputed = computed(() => {
    return { width: `calc(${getStyle.value.elementWidth}px)` };
});

const elementWidthComputed = computed(() => {
    return { '--elementWidth': `calc(${getStyle.value.elementWidth}px - 5.5rem)` };
});

const showTopbar = computed(() => {
    if (props.post.body) {
        if (props.post.title.post.toLowerCase().endsWith('.pdf'))
            return true;
        const fileType = getFileType(props.post.body, props.post.title.post)
        return (fileType && fileType !== 'misc' && fileType !== 'h5p') || (props.post.body.image && props.post.body.logo);
    }
    return false;
});

const isMagnifiedPostOpen = ref(false);
const handleShowMagnifiedPost = (value: boolean) => {
    isMagnifiedPostOpen.value = value;
};

</script>
<template>
    <div class="timeline-element relative" :class="[props.postIndex === 0 ? 'mr-10' : 'ml-10']"
        :style="[elementWidthComputed, { '--circleColor': getLineElementsColor }]" v-if="((getUserType === userType.USER && (props.post?.visible && props.post?.authorized)) || (getUserType !== userType.USER))">
        <div class="relative box-border bg-white text-gray-500 shadow-md post min-w-36 min-h-20" :key="post.id"
            :id="post.id + 'inner'"
            :style="[{ background: post.color }, { '--bgColor': post.color }, postWidthComputed]"
            :class="[post.shape, { 'shadow': handleMode !== handleModeEnum.EDIT }, { 'outline-4 outline-dashed outline-red-500': !props.post.visible }, props.postIndex === 0 ? 'ml-0' : '-ml-10']"
            >
            <div class="circle rounded-full size-5 absolute left-[calc(50%-0.75rem)]"
                :class="[{ 'header-handle cursor-grab': getFullUsable }]"></div>
            <div ref="element" class="flex flex-col gap-1">
                <div class="flex flex-row z-50 px-2"
                    :class="[{ 'draggable cursor-grab header-handle': getFullUsable }, { 'bg-white/80': showTopbar }, 'tb-' + post.shape]">
                    <div class="min-h-7 p-1 hyphens-auto w-full max-h-7 text-ellipsis line-clamp-1" lang="de"
                        :id="'handle_' + post.id">
                        <strong>{{ post.title.headline }}</strong>
                    </div>
                    <div class="ml-auto z-40 flex flex-row gap-0.5">
                        <Tooltip :tooltip="$t('tooltips.expandPost')">
                            <button class="rounded-md hover:bg-gray-100 px-1 w-7 text-lg"
                                @click="() => handleShowMagnifiedPost(true)"><i
                                    class="ri-expand-diagonal-line"></i></button>
                        </Tooltip>
                        <ElementDropdown :color="post.color" :shape="post.shape" :post="post"
                            :postIndex="props.postIndex" @edit="editPost" v-if="getFullUsable"/>
                    </div>
                </div>
                <div class="-mt-8" v-if="post.body">
                    <div class="post-content-media grow flex-auto h-full">
                        <Embedded class="w-full" :key="post.title.post" :body="post.body" :url="post.title.post"
                            :fontSize="getStyle.fontSize" :info="post.info" :topbarClass="'tb-' + post.shape"
                            v-if="post.title.post && post.title.post.length > 0" />
                    </div>
                </div>
                <div ref="handle" class="min-h-2" v-else>
                    <div class="post-content grow flex-auto">
                        <TextView :fontSize="getStyle.fontSize" :content="post.title.post" @dblclick="editPost"
                            v-if="post.title.post && getFullUsable && !post.body"
                            :font-style="getStyle?.font ? getStyle.font : ''" :content-length="-1" />
                        <TextView :fontSize="getStyle.fontSize" :content="post.title.post"
                            v-else-if="post.title.post && !post.body" :font-style="getStyle?.font ? getStyle.font : ''"
                            :content-length="-1" />
                    </div>
                </div>
                <div class="flex flex-row justify-between p-1"
                    v-if="(getLikesAllowed || getCommentsAllowed) && post.authorized">
                    <div class="w-fit">
                        <LikeButton :likes="post.likes" :likeSymbol="getStyle.likeSymbol" @click="likePostHandler"
                            v-if="getLikesAllowed" />
                    </div>

                    <div class="w-fit">
                        <button class="size-7 p-1 hover:bg-gray-100 rounded-md z-10 relative"
                            @click="changeVisibility(true)"
                            v-if="(getUserType !== userType.USER && !props.post.visible)"><i
                                class="ri-eye-off-line leading-5 text-[20px] text-teal-500"></i></button>
                    </div>
                    <div class="w-fit">
                        <Tooltip :tooltip="$t('contentPage.comment.label.pl')" v-if="getCommentsAllowed">
                            <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md"
                                @click="openCommentCanvas">
                                <span class="text-xs leading-7 align-bottom"
                                    v-if="getCommentsLength <= 99 && getCommentsLength > 0">{{ getCommentsLength
                                    }}</span>
                                <span class="text-xs leading-7 align-bottom"
                                    v-else-if="getCommentsLength > 99">99+</span>
                                <i class="ri-discuss-line leading-5 text-[20px]"></i>
                            </button>
                        </Tooltip>
                    </div>
                </div>
                <div class="flex justify-between w-full p-1" v-if="!post.authorized">
                    <div class="w-12">
                        <Tooltip :tooltip="$t('tooltips.reject')">
                            <Button variant="cancel" size="small" @click="showRejectDeleteModal(true)"><span><i
                                        class="ri-close-line text-lg"></i></span></Button>
                        </Tooltip>
                    </div>
                    <div class="w-12">
                        <Tooltip :tooltip="$t('general.buttons.confirm')">
                            <Button variant="confirm" size="small" @click="submitAuthorization"><span><i
                                        class="ri-check-line text-lg"></i></span></Button>
                        </Tooltip>
                    </div>
                </div>
            </div>
        </div>
        <Modal :labelSubmit="$t('adminMenu.pageDelete.submit')" :labelCancel="$t('general.buttons.cancel')"
            @submit="rejectAuthorization" @cancel="showRejectDeleteModal(false)"
            :text="$t('contentPage.post.deletePost')" :font="getStyle?.font ? getStyle.font : ''"
            v-if="isRejectDeleteModal"></Modal>
        <MagnifiedPost v-if="isMagnifiedPostOpen" @close="() => handleShowMagnifiedPost(false)" :post="post"
            @like="likePostHandler" @comments="openCommentCanvas" @visibility="changeVisibility" type="Timeline"
            :inert="showComments" :postIndex="props.postIndex" />
    </div>
</template>
<style scoped>
.circle {
    background-color: var(--circleColor);
}

.timeline-element:nth-child(even) .circle {
    bottom: -38px;

}

.timeline-element:nth-child(odd) .circle {
    top: -38px;
}

.circle-grab {
    cursor: grab;
}

.timeline-element {
    width: var(--elementWidth);
    min-width: var(--elementWidth);
    max-width: var(--elementWidth);
    height: calc(100dvh - 160px);
}

/*.timeline-element:nth-child(2)>.post{
    margin-left:-3rem;
}*/


.timeline-element:nth-child(even)>.post {
    top: calc(calc(100dvh / 2) - 67px);
    transform: translateY(-100%);
    bottom: 0px;
    max-height: calc(calc(100dvh - 240px) / 2);
    /*height: fit-content;*/
}

.timeline-element:nth-child(even) .post-content {
    max-height: calc(calc(calc(100dvh - 392px) / 2));
    overflow: auto;
}

.timeline-element:nth-child(even) .post-content-media {
    max-height: calc(calc(calc(100dvh - 320px) / 2));
    overflow: auto;
}

.timeline-element:nth-child(odd)>.post {
    top: calc(calc(100dvh / 2) - 11px);
    max-height: calc(calc(100dvh - 100px) / 2);
}

.timeline-element:nth-child(odd) .post-content {
    max-height: calc(calc(calc(100dvh - 220px) / 2) - 50px);
    overflow: auto;
}

.timeline-element:nth-child(odd) .post-content-media {
    max-height: calc(calc(calc(100dvh - 220px) / 2) - 20px);
    overflow: auto;
}

.timeline-element:nth-child(even) .post-content:after {
    content: "";
    position: absolute;
    width: 15px;
    height: 15px;
    background: var(--bgColor);
    transform: rotate(45deg);
    top: calc(100% - 8px);
    left: calc(50% - 9px);
    filter: drop-shadow(2px 2px 1px rgb(0 0 0 / 8%));
}

.timeline-element:nth-child(odd) .post-content:after {
    content: "";
    position: absolute;
    width: 15px;
    height: 15px;
    background: var(--bgColor);
    transform: rotate(45deg);
    bottom: calc(100% - 8px);
    left: calc(50% - 9px);
    filter: drop-shadow(-2px -2px 1px rgb(0 0 0 / 8%));
}

.timeline-element:nth-child(even) .post-content-media:after {
    content: "";
    position: absolute;
    width: 15px;
    height: 15px;
    background: var(--bgColor);
    transform: rotate(45deg);
    top: calc(100% - 8px);
    left: calc(50% - 9px);
    filter: drop-shadow(2px 2px 1px rgb(0 0 0 / 8%));
}

.timeline-element:nth-child(odd) .post-content-media:after {
    content: "";
    position: absolute;
    width: 15px;
    height: 15px;
    background: var(--bgColor);
    transform: rotate(45deg);
    bottom: calc(100% - 8px);
    left: calc(50% - 9px);
    filter: drop-shadow(-2px -2px 1px rgb(0 0 0 / 8%));
}
</style>